import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useEffect, useRef } from 'react';
import PropTypes from 'prop-types';
import { CAROUSEL_ITEMS_INITIAL_COUNT } from './carousel.constants';
export var CarouselItem = function CarouselItem(props) {
  var index = props.index,
      addItem = props.addItem,
      removeItem = props.removeItem,
      children = props.children,
      restProps = _objectWithoutProperties(props, ["index", "addItem", "removeItem", "children"]);

  var ref = useRef();
  useEffect(function () {
    addItem(index, ref, index < CAROUSEL_ITEMS_INITIAL_COUNT);
    return function () {
      removeItem(index);
    };
  }, []);
  return React.cloneElement(children, _objectSpread({}, restProps, {}, children.props, {
    ref: ref
  }));
};
CarouselItem.propTypes = {
  index: PropTypes.number.isRequired,
  addItem: PropTypes.func.isRequired,
  removeItem: PropTypes.func.isRequired,
  children: PropTypes.element.isRequired
};