import _extends from "@babel/runtime/helpers/extends";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/* global window, IntersectionObserver */
import React from 'react';
import PropTypes from 'prop-types';
import scrollIntoView from 'smooth-scroll-into-view-if-needed';
export var scrollTo = function scrollTo(element) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return scrollIntoView(element, _objectSpread({
    behavior: 'smooth',
    block: 'start'
  }, options));
};
var INTERSECTION_OBSERVER_TRESHOLD = 0.5;
export var carouselContainer = function carouselContainer(BaseComponent) {
  var CarouselContainer =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(CarouselContainer, _React$Component);

    // Items IntersectionObservers
    // Items DOM references
    function CarouselContainer(props) {
      var _this;

      _classCallCheck(this, CarouselContainer);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(CarouselContainer).call(this, props));

      _defineProperty(_assertThisInitialized(_this), "wrapperRef", {});

      _defineProperty(_assertThisInitialized(_this), "itemsObservers", {});

      _defineProperty(_assertThisInitialized(_this), "itemsRefs", {});

      _defineProperty(_assertThisInitialized(_this), "createItemIntersectionObserver", function (itemIndex, itemRef) {
        var _this$props = _this.props,
            itemIntersectionObserverEnabled = _this$props.itemIntersectionObserverEnabled,
            itemIntersectionThreshold = _this$props.itemIntersectionThreshold; // Skip If item intersection is not enabled

        if (!itemIntersectionObserverEnabled) {
          return;
        }

        var itemIntersectionObserver = new IntersectionObserver(function (entries) {
          entries.forEach(function (entry) {
            return _this.updateItem(itemIndex, entry.isIntersecting);
          });
        }, {
          root: _this.wrapperRef.current,
          threshold: itemIntersectionThreshold
        });
        _this.itemsObservers[itemIndex] = itemIntersectionObserver;
        window.requestAnimationFrame(function () {
          itemIntersectionObserver.observe(itemRef.current);
        });
      });

      _defineProperty(_assertThisInitialized(_this), "startIntersectionObserver", function () {
        _this.intersectionObserver = new IntersectionObserver(function (entries) {
          entries.forEach(function (_ref) {
            var isIntersecting = _ref.isIntersecting;
            return _this.toggleInViewport(isIntersecting);
          });
        });
        window.requestAnimationFrame(function () {
          _this.intersectionObserver.observe(_this.wrapperRef.current);
        });
      });

      _defineProperty(_assertThisInitialized(_this), "toggleInViewport", function (nextInViewport) {
        var inViewport = _this.state.inViewport;

        if (nextInViewport === inViewport) {
          return;
        }

        _this.setState({
          inViewport: nextInViewport
        });

        var _this$props2 = _this.props,
            onViewportIn = _this$props2.onViewportIn,
            onViewportOut = _this$props2.onViewportOut;

        if (nextInViewport === true && onViewportIn) {
          onViewportIn();
        }

        if (nextInViewport === false && onViewportOut) {
          onViewportOut();
        }
      });

      _defineProperty(_assertThisInitialized(_this), "scrollItem", function (element, inlineElement) {
        // @NOTE this can cause race conditions when we have another scroll in progress
        _this.setState({
          hasItemsScrollingIntoView: true
        }, function () {
          scrollTo(element, {
            block: 'nearest',
            inline: inlineElement
          }).then(function () {
            _this.setState({
              hasItemsScrollingIntoView: false
            });
          })["catch"](function (err) {
            console.error(err); // eslint-disable-line no-console
          });
        });
      });

      _defineProperty(_assertThisInitialized(_this), "showNextItems", function () {
        var itemsVisibility = _this.state.itemsVisibility;

        var reversedVisibleItems = _toConsumableArray(itemsVisibility).reverse();

        var nextOffCanvasItemId = itemsVisibility.length - reversedVisibleItems.findIndex(function (item) {
          return item;
        });
        var nextOffCanvasItem = _this.itemsRefs[nextOffCanvasItemId].current;

        if (nextOffCanvasItem) {
          _this.scrollItem(nextOffCanvasItem, 'start');
        }
      });

      _defineProperty(_assertThisInitialized(_this), "showPrevItems", function () {
        var itemsVisibility = _this.state.itemsVisibility;
        var prevOffCanvasItemId = itemsVisibility.findIndex(function (item) {
          return item;
        }) - 1;
        var prevOffCanvasItem = _this.itemsRefs[prevOffCanvasItemId].current;

        if (prevOffCanvasItem) {
          _this.scrollItem(prevOffCanvasItem, 'end');
        }
      });

      _defineProperty(_assertThisInitialized(_this), "showItem", function (id) {
        var itemRef = _this.itemsRefs[id];

        _this.scrollItem(itemRef.current, 'start');
      });

      _defineProperty(_assertThisInitialized(_this), "addItem", function (itemIndex, ref) {
        var isVisible = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        _this.itemsRefs[itemIndex] = ref;

        _this.setState(function (_ref2) {
          var itemsVisibility = _ref2.itemsVisibility;
          return {
            itemsVisibility: [].concat(_toConsumableArray(itemsVisibility.slice(0, itemIndex)), [isVisible], _toConsumableArray(itemsVisibility.slice(itemIndex + 1)))
          };
        });

        _this.createItemIntersectionObserver(itemIndex, ref);
      });

      _defineProperty(_assertThisInitialized(_this), "updateItem", function (itemIndex, isVisible) {
        var itemsVisibility = _this.state.itemsVisibility; // Ignore changes if the value is the same
        // Avoid calling setState at any cost especially to avoid multiple re-renders during the
        // insertion of the itemsVisibilityVisibility, event there might be some inconsistencies

        if (itemsVisibility[itemIndex] === isVisible) {
          return;
        }

        _this.setState(function (_ref3) {
          var prevItemsVisibility = _ref3.itemsVisibility;
          return {
            itemsVisibility: [].concat(_toConsumableArray(prevItemsVisibility.slice(0, itemIndex)), [isVisible], _toConsumableArray(prevItemsVisibility.slice(itemIndex + 1)))
          };
        });
      });

      _defineProperty(_assertThisInitialized(_this), "removeItem", function (itemIndex) {
        _this.setState(function (_ref4) {
          var itemsVisibility = _ref4.itemsVisibility;

          _this.itemsObservers[itemIndex].disconnect();

          _this.itemsObservers[itemIndex] = null;
          _this.itemsRefs[itemIndex] = null;
          return {
            itemsVisibility: [].concat(_toConsumableArray(itemsVisibility.slice(0, itemIndex)), _toConsumableArray(itemsVisibility.slice(itemIndex + 1)))
          };
        });
      });

      _this.wrapperRef = React.createRef();
      _this.state = {
        itemsVisibility: [],
        inViewport: false,
        hasItemsScrollingIntoView: false
      };
      return _this;
    }

    _createClass(CarouselContainer, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.startIntersectionObserver();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        [this.intersectionObserver].concat(_toConsumableArray(Object.values(this.itemsObservers))).forEach(function (intersectionObserver) {
          return intersectionObserver && intersectionObserver.disconnect();
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this$state = this.state,
            itemsVisibility = _this$state.itemsVisibility,
            inViewport = _this$state.inViewport,
            hasItemsScrollingIntoView = _this$state.hasItemsScrollingIntoView;
        var _this$props3 = this.props,
            itemIntersectionObserverEnabled = _this$props3.itemIntersectionObserverEnabled,
            lazyRender = _this$props3.lazyRender;
        var hasPrevItems = Boolean(itemIntersectionObserverEnabled && itemsVisibility && itemsVisibility.length && itemsVisibility[0] === false);
        var hasNextItems = Boolean(itemIntersectionObserverEnabled && itemsVisibility && itemsVisibility.length && itemsVisibility[itemsVisibility.length - 1] === false);
        return React.createElement(BaseComponent, _extends({}, this.props, {
          wrapperRef: this.wrapperRef,
          itemsVisibility: itemsVisibility,
          inViewport: inViewport,
          hasItemsScrollingIntoView: hasItemsScrollingIntoView,
          lazyRender: lazyRender,
          hasPrevItems: hasPrevItems,
          hasNextItems: hasNextItems,
          showItem: this.showItem,
          showNextItems: this.showNextItems,
          showPrevItems: this.showPrevItems,
          addItem: this.addItem,
          removeItem: this.removeItem
        }));
      }
    }]);

    return CarouselContainer;
  }(React.Component);

  CarouselContainer.propTypes = {
    lazyRender: PropTypes.bool,
    onViewportIn: PropTypes.func,
    onViewportOut: PropTypes.func,
    itemIntersectionObserverEnabled: PropTypes.bool,
    itemIntersectionThreshold: PropTypes.number
  };
  CarouselContainer.defaultProps = {
    lazyRender: false,
    onViewportIn: null,
    onViewportOut: null,
    itemIntersectionObserverEnabled: false,
    itemIntersectionThreshold: INTERSECTION_OBSERVER_TRESHOLD
  };
  return CarouselContainer;
};